Package: groovy.ui

## [Java] Class GroovyMain

- groovy.ui.GroovyMain

-     public class GroovyMain
      extends Object

  A Command line to execute groovy.

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `GroovyMain.VersionProvider` | Supplies version text for the command-line interface.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public static String` | `buildConfigScriptText(List<String> transforms)` Builds a configuration script that applies the supplied transformations.
    `` | `protected GroovyCodeSource` | `getScriptSource(boolean isScriptFile, String script)` Get a new GroovyCodeSource for a script which may be given as a location (isScript is true) or as text (isScript is false).
    `` | `public String` | `getText(String uriOrFilename)` Get the text of the Groovy script at the given location.
    `` | `public File` | `huntForTheScriptFile(String input)` Hunt for the script file by calling searchForGroovyScriptFile(String).
    `` | `public static void` | `main(String[] args)` Main CLI interface.
    `` | `public static void` | `processConfigScriptText(String scriptText, CompilerConfiguration conf)` Evaluates inline configuration script text against the supplied compiler configuration.
    `` | `public static void` | `processConfigScripts(List<String> scripts, CompilerConfiguration conf)` Evaluates configuration scripts against the supplied compiler configuration.
    `` | `public static File` | `searchForGroovyScriptFile(String input)` Search for the script file, doesn't bother if it is named precisely.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### public static String buildConfigScriptText(List<String> transforms)

      Builds a configuration script that applies the supplied transformations.

      Parameters:
        `transforms` - the transformation declarations
      Returns:
        the generated configuration script text

    - #### protected GroovyCodeSource getScriptSource(boolean isScriptFile, String script)

      Get a new GroovyCodeSource for a script which may be given as a location (isScript is true) or as text (isScript is false).

      throws:
        IOException
      throws:
        URISyntaxException
      Parameters:
        `isScriptFile` - indicates whether the script parameter is a location or content
        `script` - the location or context of the script
      Returns:
        a new GroovyCodeSource for the given script
      Since:
        2.3.0

    - #### @Deprecated
      public String getText(String uriOrFilename)

      Get the text of the Groovy script at the given location. If the location is a file path and it does not exist as given, then GroovyMain.huntForTheScriptFile is called to try with some Groovy extensions appended. This method is not used to process scripts and is retained for backward compatibility. If you want to modify how GroovyMain processes scripts then use GroovyMain.getScriptSource.

      throws:
        IOException
      deprecated:
      Parameters:
        uriOrFilename
      Returns:
        the text content at the location

    - #### public File huntForTheScriptFile(String input)

      Hunt for the script file by calling searchForGroovyScriptFile(String).

      See Also:
        GroovyMain.searchForGroovyScriptFile

    - #### public static void main(String[] args)

      Main CLI interface.

      Parameters:
        `args` - all command line args.

    - #### public static void processConfigScriptText(String scriptText, CompilerConfiguration conf)

      Evaluates inline configuration script text against the supplied compiler configuration.

      Parameters:
        `scriptText` - the configuration script text
        `conf` - the configuration to customize

    - #### public static void processConfigScripts(List<String> scripts, CompilerConfiguration conf)

      Evaluates configuration scripts against the supplied compiler configuration.

      throws:
        IOException if a script cannot be read
      Parameters:
        `scripts` - the configuration script paths
        `conf` - the configuration to customize

    - #### public static File searchForGroovyScriptFile(String input)

      Search for the script file, doesn't bother if it is named precisely. Tries in this order: - actual supplied name - name.groovy - name.gvy - name.gy - name.gsh

      Since:
        2.3.0